# class Bundler::CLI::Info

### Attributes

gem_name[R]
options[R]

### Public Class Methods

new(options, gem_name) click to toggle source

    # File lib/bundler/cli/info.rb, line 6
    def initialize(options, gem_name)
      @options = options
      @gem_name = gem_name
    end

### Public Instance Methods

run() click to toggle source

    # File lib/bundler/cli/info.rb, line 11
    def run
      spec = spec_for_gem(gem_name)

      spec_not_found(gem_name) unless spec
      return print_gem_path(spec) if @options[:path]
      print_gem_info(spec)
    end

### Private Instance Methods

default_gem_spec(gem_name) click to toggle source

    # File lib/bundler/cli/info.rb, line 26
    def default_gem_spec(gem_name)
      return unless Gem::Specification.respond_to?(:find_all_by_name)
      gem_spec = Gem::Specification.find_all_by_name(gem_name).last
      return gem_spec if gem_spec && gem_spec.respond_to?(:default_gem?) && gem_spec.default_gem?
    end

print_gem_info(spec) click to toggle source

    # File lib/bundler/cli/info.rb, line 40
    def print_gem_info(spec)
      gem_info = String.new
      gem_info << "  * #{spec.name} (#{spec.version}#{spec.git_version})\n"
      gem_info << "\tSummary: #{spec.summary}\n" if spec.summary
      gem_info << "\tHomepage: #{spec.homepage}\n" if spec.homepage
      gem_info << "\tPath: #{spec.full_gem_path}\n"
      gem_info << "\tDefault Gem: yes" if spec.respond_to?(:default_gem?) && spec.default_gem?
      Bundler.ui.info gem_info
    end

print_gem_path(spec) click to toggle source

    # File lib/bundler/cli/info.rb, line 36
    def print_gem_path(spec)
      Bundler.ui.info spec.full_gem_path
    end

spec_for_gem(gem_name) click to toggle source

    # File lib/bundler/cli/info.rb, line 21
    def spec_for_gem(gem_name)
      spec = Bundler.definition.specs.find {|s| s.name == gem_name }
      spec || default_gem_spec(gem_name)
    end

spec_not_found(gem_name) click to toggle source

    # File lib/bundler/cli/info.rb, line 32
    def spec_not_found(gem_name)
      raise GemNotFound, Bundler::CLI::Common.gem_not_found_message(gem_name, Bundler.definition.dependencies)
    end